CREATE OR ALTER VIEW VW_WARES(
    MMBSH,
    SREP,
    REP_ID,
    ID,
    NAME_ID,
    SNAME,
    IZG_ID,
    SIZG,
    COUNTRY_ID,
    SCOUNTRY,
    ORIG_CODE,
    ORIG_NAME_ID,
    SORIG_NAME,
    ORIG_IZG_ID,
    SORIG_IZG,
    ORIG_COUNTRY_ID,
    SORIG_COUNTRY,
    BARCODE,
    Z_ID,
    SKLAD_ID,
    INSERTDT,
    PACKET,
    MGN_NAME,
    MGN_ID,
    MGN_SOURCE
    ,ALT_TYPE
    )
AS
select
(select MEMBERSHIP from PR_MEMBERSHIPS('PARTS.NAME_ID=' || W.NAME_ID || ';PARTS.WARE_ID=' || W.ID || ';', ascii_char(13) || ascii_char(10), 1)),
iif(w.rep_id is null, '', (select svalue from vals where id = w.rep_id)),
REP_ID,
w.ID,
w.NAME_ID,
w.sname,
w.IZG_ID,
(select svalue from vals where id = w.izg_id),
w.COUNTRY_ID,
(select svalue from vals where id = w.country_id),
w.ORIG_CODE,
w.ORIG_NAME_ID,
(select svalue from vals where id = w.orig_name_id),
w.ORIG_IZG_ID,
(select svalue from vals where id = w.orig_izg_id),
w.ORIG_COUNTRY_ID,
(select svalue from vals where id = w.orig_country_id),
w.BARCODE,
w.Z_ID,
w.SKLAD_ID,
w.INSERTDT,
w.PACKET,
w.mgn_name,
w.mgn_id,
w.mgn_source
w.alttype
from wares w order by sname, BARCODE
;
CREATE OR ALTER VIEW VW_DOC_DETAIL(
    ACCEPTED,
    ACCEPTANCE,
    EGAIS_PRODUCER_ID,
    ID,
    PARENT_ID,
    DOC_ID,
    PART_ID,
    PART_PARENT_ID,
    PRICE,
    QUANT,
    DISCOUNT,
    SUMMA,
    SUMMA_O,
    DCARD,
    INSERTDT,
    WARE_ID,
    NAME_ID,
    SNAME,
    IZG_ID,
    SIZG,
    COUNTRY_ID,
    SCOUNTRY,
    ORIG_CODE,
    SORIG_NAME,
    SORIG_IZG,
    SORIG_COUNTRY,
    BCODE_IZG,
    PRICE_O,
    PRICE_Z,
    PRICE_R,
    BARCODE,
    BARCODE1,
    DEP,
    KRITK,
    GODENDO,
    SERIA,
    SUM_NDSO,
    SUM_NDSR,
    SERT,
    DATESERT,
    KEMVSERT,
    SDSERT,
    REGN,
    NGTD,
    EDIZM,
    NDS,
    MMBSH,
    NDSBYDEP,
    BLOCK_QUANT,
    DOC_COMMITDATE,
    MOTHERPART_ID,
    HUMAN_QUANT,
    SUM_DSC,
    PART_TYPE,
    PACKET,
    BASE_AGENT_ID,
    SBASE_AGENT_ID,
    CONTRACT_ID,
    NAC,
    VSHIFT,
    DEVICE_NUM,
    VNUM,
    DOC_STATUS,
    DOC_TYPE,
    MAKE_ID,
    FIO,
    GROUP_ID,
    SKLAD_ID,
    STORE_STRING,
    BARC_LABEL_COUNT,
    MGN_NAME,
    MGN_ID,
    MGN_SOURCE,
    RECEPT,
    FIO_ID,
    FIO_BOLNOY_ID,
    TYPE_LGOTA,
    PRICE_DSC,
    MOTHERPART_UUID,
    EGAIS_ID,
    EGAIS_BREGID,
    EGAIS_REGID,
    EGAIS_ALCCODE,
    CAPACITY,
    ALC_VOLUME,
    EGAIS_TTNID,
    EGAIS_QUANT,
    D$UUID,
    FIRST_AGENTS)
AS
select
(case when char_length(acceptance)>0 then 1 else 0 end),
ACCEPTANCE,
p.egais_producer_id,
dt.ID,
dt.PARENT_ID,
dt.DOC_ID,
dt.PART_ID,
p.parent_id,
p.PRICE,
dt.QUANT,
dt.DISCOUNT,
dt.SUMMA,
dt.SUMMA_O,
dt.DCARD,
dt.INSERTDT,
p.WARE_ID,
w.name_id,
vname.svalue, --SNAME,
w.izg_id,
vizg.svalue, --SIZG,
w.country_id,
vcountry.svalue, --SCOUNTRY,
ORIG_CODE,
vorig_name.svalue, --Sorig_NAME,
vorig_izg.svalue, --Sorig_IZG,
vorig_country.svalue, --Sorig_COUNTRY,
w.barcode,-- BCODE_IZG,
p.PRICE_O,
p.PRICE_Z,
p.PRICE_R,
p.BARCODE,
p.BARCODE1,
p.DEP,
vname.intvalue, --p.KRITK,
p.GODENDO,
p.SERIA,
dt.SUM_NDSO,
dt.SUM_NDSR,
p.SERT,
p.DATESERT,
p.KEMVSERT,
p.SDSERT,
p.REGN,
p.NGTD,
p.EDIZM,
p.NDS,
(select membership from PR_MEMBERSHIPS('PARTS=' || dt.part_id || ';PARTS.NAME_ID=' || w.name_id || ';PARTS.WARE_ID=' || w.ID || ';PARTS.IZG_ID=' || w.izg_id ||';',ascii_char(13)||ascii_char(10),1)),
deps.nds,
(select BLOCK_QUANT from warebase where part_id=p.id),
DT.doc_commitdate,
p.motherpart_id,
dt.human_quant,
dt.SUM_DSC,
dt.part_type,
dt.packet,
dt.BASE_AGENT_ID,
(select caption from agents where id=dt.BASE_AGENT_ID),
p.contract_id,
DT.NAC,
d.vshift,
d.device_num,
d.vnum,
d.status,
d.doc_type,
dt.make_id,
(select od.fio from DOC_DETAIL_DOCTOR docdoc left join out$traders od on docdoc.doctor_id=od.id where docdoc.doc_detail_id =dt.id),
p.group_id,
p.SKLAD_ID,
(select svalue from pr_getattribute('store_string', w.name_id)),
(select svalue from pr_getattribute('barc_label_count', w.name_id)),
w.mgn_name,
w.mgn_id,
w.mgn_source,
dt.RECEPT,
dt.FIO_ID,
dt.FIO_BOLNOY_ID,
dt.TYPE_LGOTA,
iif(dt.quant between -0.000001 and 0.000001,0,cast(dt.summa/dt.quant as numeric(15,4)))
 ,P.MOTHERPART_UUID  ,P.EGAIS_ID  ,P.EGAIS_BREGID  ,P.EGAIS_REGID  ,P.EGAIS_ALCCODE  ,P.CAPACITY  ,P.ALC_VOLUME  ,D.EGAIS_ID  ,P.EGAIS_QUANT,
dt.D$UUID,
--add avo 09/12/19 контрагент первичного прихода (нужен для ценников)
(select d.sagent from vw_docs d where d.id=(select dd.doc_id from doc_detail dd where dd.part_id=dt.part_id and dd.agent_first is not null))
from
doc_detail dt
left join parts p on dt.part_id=p.id
left join WARES w on p.ware_id=w.id
left join vals vname on w.name_id=vname.id
left join docs d on d.id=dt.doc_id
left join vals vizg on w.izg_id=vizg.id
left join vals vcountry on w.country_id=vcountry.id
left join vals vorig_name on w.orig_name_id=vorig_name.id
left join vals vorig_izg on w.orig_izg_id=vorig_izg.id
left join vals vorig_country on w.orig_country_id=vorig_country.id
left join deps on p.dep=deps.id
;

CREATE OR ALTER VIEW VW_DOC_DETAIL_ACTIVE(
    MARK_BARCODE,
    ACCEPTED,
    ACCEPTANCE,
    AGENT_FIRST,
    DATE_FIRST_PRIHOD,
    REP_ID,
    ID,
    PARENT_ID,
    DOC_ID,
    PART_ID,
    PART_PARENT_ID,
    DOC_DETAIL_ID,
    PRICE,
    NAC,
    QUANT,
    DISCOUNT,
    SUMMA,
    SUMMA_O,
    DCARD,
    WARE_ID,
    PRICE_O,
    PRICE_Z,
    PRICE_R,
    BARCODE,
    BARCODE1,
    BCODE_IZG,
    KRITK,
    GODENDO,
    SERIA,
    NDS,
    SUM_NDSO,
    SUM_NDSR,
    SERT,
    DATESERT,
    KEMVSERT,
    SDSERT,
    REGN,
    NGTD,
    EDIZM,
    NAME_ID,
    IZG_ID,
    COUNTRY_ID,
    ORIG_CODE,
    ORIG_NAME_ID,
    ORIG_IZG_ID,
    ORIG_COUNTRY_ID,
    Z_ID,
    SKLAD_ID,
    SNAME,
    SIZG,
    SCOUNTRY,
    SORIG_NAME,
    SORIG_IZG,
    SORIG_COUNTRY,
    INSERTDT,
    INFO,
    KOEF,
    MOTHERPART_ID,
    DEP,
    MMBSH,
    NDSBYDEP,
    REALQUANT,
    PRICE_DSC,
    BLOCK_QUANT,
    SUM_DSC,
    HUMAN_QUANT,
    CUSTOMDRAW,
    STATUS,
    OLDPRICE,
    PART_TYPE,
    PRICES,
    BASE_AGENT_ID,
    SBASE_AGENT_ID,
    GNVLS,
    GROUP_ID,
    MAKE_ID,
    MNN,
    FIO,
    STORE_STRING,
    BARC_LABEL_COUNT,
    SGROUP_ID,
    MGN_NAME,
    MGN_ID,
    MGN_SOURCE,
    MOTHERPART_UUID,
    EGAIS_ID,
    EGAIS_BREGID,
    EGAIS_REGID,
    EGAIS_ALCCODE,
    CAPACITY,
    ALC_VOLUME,
    EGAIS_PRODUCER_ID,
    EGAIS_QUANT,
    BOTTLINGDATE,
    EGAIS_BARCODE,
    D$UUID,
    MARK_COUNT,
    FIRST_SAGENT)
AS
select (select concatenation  from pr_mark_count(da.id)),
         (
         case
           when char_length(DA.ACCEPTANCE) > 0 then 1
           else 0
         end),
         ACCEPTANCE, DA.AGENT_FIRST, DA.DATE_FIRST_PRIHOD, REP_ID, DA.ID, PARENT_ID, DOC_ID, PART_ID, PART_PARENT_ID,
         DOC_DETAIL_ID, PRICE, cast(NAC as numeric(15,2)), QUANT,
         iif(((DA.PRICE = 0) or (DA.QUANT = 0)), 0, iif(DISCOUNT > 0.01, DISCOUNT, -DA.SUM_DSC / (DA.PRICE * DA.QUANT) * 100)),
         SUMMA, SUMMA_O, DCARD, WARE_ID, PRICE_O, PRICE_Z, PRICE_R, BARCODE, BARCODE1, BCODE_IZG,
         (select INTVALUE
          from VALS
          where ID = DA.NAME_ID), --KRITK,
         GODENDO, SERIA, DA.NDS, SUM_NDSO, SUM_NDSR, SERT, DATESERT, KEMVSERT, SDSERT, REGN, NGTD, EDIZM, NAME_ID,
         IZG_ID, COUNTRY_ID, ORIG_CODE, ORIG_NAME_ID, ORIG_IZG_ID, ORIG_COUNTRY_ID, Z_ID, SKLAD_ID, SNAME, SIZG,
         SCOUNTRY, SORIG_NAME, SORIG_IZG, SORIG_COUNTRY, DA.INSERTDT, INFO, KOEF, MOTHERPART_ID, DEP,
         (select MEMBERSHIP
          from PR_MEMBERSHIPS('PARTS=' || DA.PART_ID || ';DOC_DETAIL_ACTIVE=' || DA.ID || ';PARTS.NAME_ID=' || DA.NAME_ID || ';PARTS.WARE_ID=' || da.ware_ID || ';PARTS.IZG_ID=' || DA.IZG_ID || ';', ascii_char(13) || ascii_char(10), 1)),
         DEPS.NDS,
         (select REALQUANT
          from WAREBASE W
          where W.PART_ID = DA.PART_ID), iif(coalesce(DA.QUANT, 0) = 0, 0, cast(DA.SUMMA / DA.QUANT as numeric(15,4))),
         (select BLOCK_QUANT
          from WAREBASE
          where PART_ID = DA.PART_ID), DA.SUM_DSC, DA.HUMAN_QUANT, DA.CUSTOMDRAW, DA.STATUS, iif(DA.PARENT_ID <> 0,
         (select DDD.PRICE
          from DOC_DETAIL_ACTIVE DDD
          where DDD.ID = DA.PARENT_ID), 0), PART_TYPE,
         (select S
         from PR_GETPARTPRICES(DA.PART_ID, DA.ID)), DA.BASE_AGENT_ID, iif(DA.BASE_AGENT_ID = 0, 'Основной склад',
         (select CAPTION
          from AGENTS
          where ID = DA.BASE_AGENT_ID)), DA.GNVLS, DA.GROUP_ID, DA.MAKE_ID, DA.MNN,
         (select OD.FIO
          from DOC_DETAIL_DOCTOR DOCDOC
          left join OUT$TRADERS OD on DOCDOC.DOCTOR_ID = OD.ID
          where DOCDOC.DOC_DETAIL_ACTIVE_ID = DA.ID),
         (select SVALUE
          from PR_GETATTRIBUTE('store_string', DA.NAME_ID)),
         (select SVALUE
          from PR_GETATTRIBUTE('barc_label_count', DA.NAME_ID)),
         --(select svalue from pr_getattribute('store_float', da.name_id)),
         (select GR.CAPTION
          from GROUPS GR
          where GR.ID = DA.GROUP_ID),
         (select MGN_NAME
          from WARES
          where ID = DA.WARE_ID) as MGN_NAME,
         (select MGN_ID
          from WARES
          where ID = DA.WARE_ID) as MGN_ID,
         (select MGN_SOURCE
          from WARES
          where ID = DA.WARE_ID) as MGN_SOURCE, DA.MOTHERPART_UUID, EGAIS_ID, EGAIS_BREGID, EGAIS_REGID, EGAIS_ALCCODE,
         CAPACITY, ALC_VOLUME, EGAIS_PRODUCER_ID, EGAIS_QUANT, BOTTLINGDATE, EGAIS_BARCODE, DA.D$UUID,
         (select CNT
          from PR_MARK_COUNT(DA.ID)),
          --add avo 09/12/19 контрагент первичного прихода (нужен для ценников)
          (select d.sagent from vw_docs d where d.id=(select dd.doc_id from doc_detail dd where dd.part_id=da.part_id and dd.agent_first is not null))
from DOC_DETAIL_ACTIVE DA
left join DEPS on DA.DEP = DEPS.ID
order by DA.PARENT_ID, DA.SNAME, DA.ID
;

CREATE OR ALTER VIEW VW_DOC_DETAIL_DELETED(
    ID,
    PARENT_ID,
    DOC_ID,
    PART_ID,
    PART_PARENT_ID,
    DOC_DETAIL_ID,
    PRICE,
    NAC,
    QUANT,
    DISCOUNT,
    SUMMA,
    SUMMA_O,
    DCARD,
    WARE_ID,
    PRICE_O,
    PRICE_Z,
    PRICE_R,
    BARCODE,
    BARCODE1,
    GODENDO,
    SERIA,
    NDS,
    SUM_NDSO,
    SUM_NDSR,
    SERT,
    DATESERT,
    KEMVSERT,
    SDSERT,
    REGN,
    NGTD,
    EDIZM,
    NAME_ID,
    IZG_ID,
    COUNTRY_ID,
    ORIG_CODE,
    ORIG_NAME_ID,
    ORIG_IZG_ID,
    ORIG_COUNTRY_ID,
    Z_ID,
    SKLAD_ID,
    SNAME,
    SIZG,
    SCOUNTRY,
    SORIG_NAME,
    SORIG_IZG,
    SORIG_COUNTRY,
    INSERTDT,
    INFO,
    MOTHERPART_ID,
    DEP,
    MMBSH,
    NDSBYDEP,
    REALQUANT,
    BLOCK_QUANT,
    SUM_DSC,
    BASE_AGENT_ID,
    SBASE_AGENT_ID,
    GROUP_ID,
    BCODE_IZG,
    STORE_STRING,
    VSHIFT,
    DEVICE_NUM,
    VNUM,
    DOC_STATUS,
    DOC_TYPE,
    DOC_COMMITDATE,
    BARC_LABEL_COUNT
    ,D$UUID
    )
AS
SELECT
da.ID,
da.PARENT_ID,
da.DOC_ID,
da.PART_ID,
da.PART_PARENT_ID,
da.DOC_DETAIL_ID,
da.PRICE,
da.NAC,
da.QUANT,
da.DISCOUNT,
da.SUMMA,
da.SUMMA_O,
da.DCARD,
da.WARE_ID,
da.PRICE_O,
da.PRICE_Z,
da.PRICE_R,
da.BARCODE,
da.BARCODE1,
--KRITK,
da.GODENDO,
da.SERIA,
da.NDS,
da.SUM_NDSO,
da.SUM_NDSR,
da.SERT,
da.DATESERT,
da.KEMVSERT,
da.SDSERT,
da.REGN,
da.NGTD,
da.EDIZM,
da.NAME_ID,
da.IZG_ID,
da.COUNTRY_ID,
da.ORIG_CODE,
da.ORIG_NAME_ID,
da.ORIG_IZG_ID,
da.ORIG_COUNTRY_ID,
da.Z_ID,
da.SKLAD_ID,
da.SNAME,
da.SIZG,
da.SCOUNTRY,
da.SORIG_NAME,
da.SORIG_IZG,
da.SORIG_COUNTRY,
da.INSERTDT,
da.INFO,
--KOEF,
da.MOTHERPART_ID,
da.DEP,
(select membership from PR_MEMBERSHIPS('PARTS=' || da.part_id || ';PARTS.NAME_ID=' || da.name_id || ';PARTS.WARE_ID=' || da.ware_ID || ';PARTS.IZG_ID=' ||da.izg_id ||';',ascii_char(13)||ascii_char(10),1)),
(select nds from deps where id=da.dep),
w.realquant,
w.block_quant,
da.SUM_DSC,
da.BASE_AGENT_ID,
(select caption from agents where id=da.BASE_AGENT_ID),
(select group_id from parts where id = da.part_id),
da.BCODE_IZG,
(select svalue from pr_getattribute('store_string', w.name_id)),
d.vshift,
d.device_num,
d.vnum,
d.status,
d.doc_type,
cast(d.commitdate as date),
(select svalue from pr_getattribute('barc_label_count', w.name_id))
,da.d$uuid
FROM
DOC_DETAIL_DELETED da
left join warebase w on da.part_id=w.part_id
left join docs d on d.id=da.doc_id
;
CREATE OR ALTER VIEW VW_DOC_DETAIL_KASSA(
    ID,
    PARENT_ID,
    DOC_ID,
    PART_ID,
    PART_PARENT_ID,
    PRICE,
    QUANT,
    DISCOUNT,
    SUMMA,
    SUMMA_O,
    DCARD,
    INSERTDT,
    WARE_ID,
    NAME_ID,
    SNAME,
    IZG_ID,
    SIZG,
    COUNTRY_ID,
    SCOUNTRY,
    ORIG_CODE,
    SORIG_NAME,
    SORIG_IZG,
    SORIG_COUNTRY,
    BCODE_IZG,
    PRICE_O,
    PRICE_Z,
    PRICE_R,
    BARCODE,
    BARCODE1,
    DEP,
    KRITK,
    GODENDO,
    SERIA,
    SUM_NDSO,
    SERT,
    DATESERT,
    KEMVSERT,
    SDSERT,
    REGN,
    NGTD,
    EDIZM,
    NDS,
    MMBSH,
    NDSBYDEP,
    BLOCK_QUANT,
    DOC_COMMITDATE,
    MOTHERPART_ID,
    HUMAN_QUANT,
    SUM_DSC,
    PART_TYPE,
    PACKET,
    BASE_AGENT_ID,
    SBASE_AGENT_ID,
    CONTRACT_ID,
    NAC
    ,D$UUID
    )
AS
select
  dt.ID,
  dt.PARENT_ID,
  dt.DOC_ID,
  dt.PART_ID,
  p.parent_id,
  p.PRICE,
  dt.QUANT,
  dt.DISCOUNT,
  dt.SUMMA,
  dt.SUMMA_O,
  dt.DCARD,
  dt.INSERTDT,
  p.WARE_ID,
  w.name_id,
  vname.svalue,
  w.izg_id,
  vizg.svalue,
  w.country_id,
  vcountry.svalue,
  ORIG_CODE,
  vorig_name.svalue,
  vorig_izg.svalue,
  vorig_country.svalue,
  w.barcode,
  p.PRICE_O,
  p.PRICE_Z,
  p.PRICE_R,
  p.BARCODE,
  p.BARCODE1,
  p.DEP,
  vname.intvalue,
  p.GODENDO,
  p.SERIA,
  dt.SUM_NDSO,
  p.SERT,
  p.DATESERT,
  p.KEMVSERT,
  p.SDSERT,
  p.REGN,
  p.NGTD,
  p.EDIZM,
  p.NDS,
  (select membership from PR_MEMBERSHIPS('PARTS=' || dt.part_id || ';PARTS.NAME_ID=' || w.name_id || ';PARTS.WARE_ID=' || p.ware_ID || ';PARTS.IZG_ID=' || w.izg_id ||';',ascii_char(13)||ascii_char(10),1)),
  deps.nds,
  (select BLOCK_QUANT from warebase where part_id=p.id),
  DT.doc_commitdate,
  p.motherpart_id,
  dt.human_quant,
  dt.SUM_DSC,
  dt.part_type,
  dt.packet,
  dt.BASE_AGENT_ID,
  (select caption from agents where id=dt.BASE_AGENT_ID),
  p.contract_id,
  DT.NAC
  ,dt.d$uuid
from
  doc_detail dt
  left join parts p on dt.part_id=p.id
  left join WARES w on p.ware_id=w.id
  left join vals vname on w.name_id=vname.id
  left join docs d on d.id=dt.doc_id
  left join vals vizg on w.izg_id=vizg.id
  left join vals vcountry on w.country_id=vcountry.id
  left join vals vorig_name on w.orig_name_id=vorig_name.id
  left join vals vorig_izg on w.orig_izg_id=vorig_izg.id
  left join vals vorig_country on w.orig_country_id=vorig_country.id
  left join deps on p.dep=deps.id
;

CREATE OR ALTER VIEW VW_DOC_DETAIL_VIRTUAL(
    REP_ID,
    ID,
    PARENT_ID,
    DOC_ID,
    PART_ID,
    PART_PARENT_ID,
    PRICE,
    QUANT,
    DISCOUNT,
    SUMMA,
    SUMMA_O,
    DCARD,
    INSERTDT,
    WARE_ID,
    NAME_ID,
    SNAME,
    IZG_ID,
    SIZG,
    COUNTRY_ID,
    SCOUNTRY,
    ORIG_CODE,
    SORIG_NAME,
    SORIG_IZG,
    SORIG_COUNTRY,
    BCODE_IZG,
    PRICE_O,
    PRICE_Z,
    PRICE_R,
    BARCODE,
    BARCODE1,
    DEP,
    KRITK,
    GODENDO,
    SERIA,
    SUM_NDSO,
    SUM_NDSR,
    SERT,
    DATESERT,
    KEMVSERT,
    SDSERT,
    REGN,
    NGTD,
    EDIZM,
    NDS,
    MMBSH,
    NDSBYDEP,
    BLOCK_QUANT,
    DOC_COMMITDATE,
    MOTHERPART_ID,
    HUMAN_QUANT,
    SUM_DSC,
    PART_TYPE,
    PACKET,
    BASE_AGENT_ID,
    SBASE_AGENT_ID,
    CONTRACT_ID,
    NAC,
    VSHIFT,
    DEVICE_NUM,
    VNUM,
    DOC_STATUS,
    PRICE_DSC,
    SKLAD_ID,
    D$UUID
    )
AS
select
REP_ID,
dtv.ID,
dtv.PARENT_ID,
dtv.DOC_ID,
dtv.PART_ID,
dtv.parent_id,
dtv.PRICE,
dtv.QUANT,
dtv.DISCOUNT,
dtv.SUMMA,
dtv.SUMMA_O,
dtv.DCARD,
dtv.INSERTDT,
dtv.WARE_ID,
dtv.name_id,
dtv.SNAME,
dtv.izg_id,
dtv.SIZG,
dtv.country_id,
dtv.SCOUNTRY,
dtv.ORIG_CODE,
dtv.SORIG_NAME,
dtv.SORIG_IZG,
dtv.SORIG_COUNTRY,
dtv.BCODE_IZG,
dtv.PRICE_O,
dtv.PRICE_Z,
dtv.PRICE_R,
dtv.BARCODE,
dtv.BARCODE1,
dtv.DEP,
0,--dtv.KRITK,
dtv.GODENDO,
dtv.SERIA,
dtv.SUM_NDSO,
dtv.SUM_NDSR,
dtv.SERT,
dtv.DATESERT,
dtv.KEMVSERT,
dtv.SDSERT,
dtv.REGN,
dtv.NGTD,
dtv.EDIZM,
dtv.NDS,
(select membership from PR_MEMBERSHIPS('PARTS=' || dtv.part_id || ';PARTS.NAME_ID=' || dtv.name_id || ';PARTS.WARE_ID=' || dtv.ware_ID || ';PARTS.IZG_ID=' || dtv.izg_id ||';',ascii_char(13)||ascii_char(10),1)),
dtv.nds,
(select BLOCK_QUANT from warebase where part_id=p.id),
d.commitdate,
dtv.motherpart_id,
dtv.human_quant,
dtv.SUM_DSC,
dtv.part_type,
dtv.packet,
dtv.BASE_AGENT_ID,
(select caption from agents where id=dtv.BASE_AGENT_ID),
p.contract_id,
dtv.NAC,
d.vshift,
d.device_num,
d.vnum,
d.status,
iif(dtv.quant between -0.000001 and 0.000001,0,dtv.sum_dsc/dtv.quant),
p.SKLAD_ID,
dtv.d$uuid
from
doc_detail_virtual dtv
left join docs d on dtv.doc_id = d.id
left join parts p on dtv.part_id=p.id
;

CREATE OR ALTER VIEW VW_WAREBASE(
    DATE_FIRST_PRIHOD,
    AGENT_FIRST,
    PART_ID,
    WARE_ID,
    SNAME,
    SIZG,
    SCOUNTRY,
    ORIG_CODE,
    ORIG_DOC_ID,
    ORIG_QUANT,
    SORIG_NAME,
    SORIG_IZG,
    SORIG_COUNTRY,
    BCODE_IZG,
    PRICE,
    PRICE_O,
    PRICE_Z,
    PRICE_R,
    QUANT,
    BARCODE,
    BARCODE1,
    DEP,
    KRITK,
    GODENDO,
    SERIA,
    SUM_NDSO,
    SERT,
    DATESERT,
    KEMVSERT,
    SDSERT,
    REGN,
    NGTD,
    EDIZM,
    DOC_ID,
    DOCNUM,
    DOCDATE,
    DOCCAPTION,
    DOCAGENT,
    DOCVNUM,
    DOCVSHIFT,
    INSERTDT,
    UPDATEDT,
    ENDDT,
    NDS,
    REALQUANT,
    PART_PARENT_ID,
    NAME_ID,
    IZG_ID,
    COUNTRY_ID,
    NAC,
    BLOCK_QUANT,
    BLOCK_COUNT,
    MMBSH,
    PART_TYPE,
    PRICES,
    BASE_AGENT_ID,
    SBASE_AGENT_ID,
    CONTRACT_ID,
    SCONTRACT_ID,
    GROUP_ID,
    SGROUP_ID,
    VPART_ID,
    SKLAD_ID,
    MNN,
    STORE_STRING,
    BARC_LABEL_COUNT,
    MGN_NAME)
AS
select
(select P.DATE_FIRST_PRIHOD from PARTS P where P.ID = WB.PART_ID),
(select P.AGENT_FIRST from PARTS P where P.ID = WB.PART_ID),
PART_ID,
WARE_ID,
SNAME,
SIZG,
SCOUNTRY,
ORIG_CODE,
(select (select ddd.id from docs ddd where ddd.id=pr.doc_id) from pr_getmotherpart(part_id) pr), /*OAV 920562*/
(select quant from parts where parts.id=wb.part_id), /*OAV 920562*/
SORIG_NAME,
SORIG_IZG,
SORIG_COUNTRY,
BCODE_IZG,
PRICE,
PRICE_O,
PRICE_Z,
PRICE_R,
QUANT,
BARCODE,
BARCODE1,
DEP,
(select intvalue from vals where id=name_id), --KRITK,
GODENDO,
SERIA,
SUM_NDSO,
SERT,
DATESERT,
KEMVSERT,
SDSERT,
REGN,
NGTD,
EDIZM,
DOC_ID, /*(select pr.doc_id from pr_getmotherpart(part_id) pr), */
DOCNUM,  /*(select (select ddd.docnum from docs ddd where ddd.id=pr.doc_id) from pr_getmotherpart(part_id) pr),*/
cast (DOCDATE as dm_date), /*(select (select ddd.docdate from docs ddd where ddd.id=pr.doc_id) from pr_getmotherpart(part_id) pr),*/
(select (select ddd.caption from docs ddd where ddd.id=pr.doc_id) from pr_getmotherpart(part_id) pr),
(select (select a.caption from agents a where a.id=pr.agent_id) from pr_getmotherpart(part_id) pr),

DOCVNUM, /*(select (select ddd.vnum from docs ddd where ddd.id=pr.doc_id) from pr_getmotherpart(part_id) pr),*/
DOCVSHIFT, /*(select (select ddd.vshift from docs ddd where ddd.id=pr.doc_id) from pr_getmotherpart(part_id) pr),*/
INSERTDT,
UPDATEDT,
ENDDT,
NDS,
REALQUANT,
PART_PARENT_ID,
NAME_ID,
IZG_ID,
COUNTRY_ID,
NAC,
BLOCK_QUANT,
BLOCK_COUNT,
(select membership from PR_MEMBERSHIPS('PARTS=' || wb.part_id || ';PARTS.NAME_ID=' || wb.name_id || ';PARTS.WARE_ID=' || wb.ware_ID || ';PARTS.IZG_ID=' || wb.izg_id ||';',ascii_char(13)||ascii_char(10),1)),
part_type,
(select s from PR_GETPARTPRICES(wb.part_id,0)),
BASE_AGENT_ID,
(select caption from agents where id=wb.BASE_AGENT_ID),
CONTRACT_ID,
SCONTRACT_ID,
GROUP_ID,
(select gr.caption from groups gr where gr.id=wb.group_id),
VPART_ID,
(select sklad_id from parts where parts.id=wb.part_id),
(select preparedvalue from vals where id=name_id),  --mnn
(select svalue from pr_getattribute('store_string', wb.name_id)),
(select svalue from pr_getattribute('barc_label_count', wb.name_id)),
(select mgn_name from wares where id = wb.ware_id)
from WAREBASE wb
;
CREATE OR ALTER VIEW VW_WAREBASEFOLDERS(
    PART_ID,
    WARE_ID,
    SNAME,
    SIZG,
    SCOUNTRY,
    ORIG_CODE,
    SORIG_NAME,
    SORIG_IZG,
    SORIG_COUNTRY,
    BCODE_IZG,
    PRICE,
    PRICE_O,
    PRICE_Z,
    PRICE_R,
    QUANT,
    BARCODE,
    BARCODE1,
    DEP,
    KRITK,
    GODENDO,
    SERIA,
    SUM_NDSO,
    SERT,
    DATESERT,
    KEMVSERT,
    SDSERT,
    REGN,
    NGTD,
    EDIZM,
    DOC_ID,
    DOCNUM,
    DOCDATE,
    DOCCAPTION,
    DOCAGENT,
    DOCVNUM,
    DOCVSHIFT,
    INSERTDT,
    UPDATEDT,
    ENDDT,
    NDS,
    REALQUANT,
    PART_PARENT_ID,
    NAME_ID,
    IZG_ID,
    COUNTRY_ID,
    NAC,
    BLOCK_QUANT,
    BLOCK_COUNT,
    MMBSH,
    PART_TYPE,
    BASE_AGENT_ID,
    SBASE_AGENT_ID,
    CONTRACT_ID,
    SCONTRACT_ID,
    GROUP_ID,
    ISFOLDER,
    VPART_ID,
    MNN)
AS
select
part_id,
ware_id,
sname,
sizg,
scountry,
orig_code,
sorig_name,
sorig_izg,
sorig_country,
bcode_izg,
price,
price_o,
price_z,
price_r,
quant,
barcode,
barcode1,
dep,
(select intvalue from vals where id=name_id), --KRITK,
godendo,
seria,
sum_ndso,
sert,
datesert,
kemvsert,
sdsert,
regn,
ngtd,
edizm,
doc_id,
docnum,
docdate,
doccaption,
docagent,
docvnum,
docvshift,
insertdt,
updatedt,
enddt,
nds,
realquant,
part_parent_id,
name_id,
izg_id,
country_id,
nac,
block_quant,
block_count,
(select membership from PR_MEMBERSHIPS('PARTS=' || wb.part_id || ';PARTS.NAME_ID=' || wb.name_id || ';PARTS.WARE_ID=' || wb.ware_ID || ';PARTS.IZG_ID=' || wb.izg_id ||';',ascii_char(13)||ascii_char(10),1)),
part_type,
base_agent_id,
(select a.caption from agents a where a.id=wb.BASE_AGENT_ID),
contract_id,
scontract_id,
group_id,
isfolder,
VPART_ID,
(select preparedvalue from vals where id=name_id)
from warebasefolders wb
;

CREATE OR ALTER VIEW VW_WAREBASENAMEID(
    PART_ID,
    WARE_ID,
    SNAME,
    SIZG,
    SCOUNTRY,
    ORIG_CODE,
    SORIG_NAME,
    SORIG_IZG,
    SORIG_COUNTRY,
    BCODE_IZG,
    PRICE,
    PRICE_O,
    PRICE_Z,
    PRICE_R,
    QUANT,
    BARCODE,
    BARCODE1,
    DEP,
    KRITK,
    GODENDO,
    SERIA,
    SUM_NDSO,
    SERT,
    DATESERT,
    KEMVSERT,
    SDSERT,
    REGN,
    NGTD,
    EDIZM,
    DOC_ID,
    DOCNUM,
    DOCDATE,
    DOCCAPTION,
    DOCAGENT,
    DOCVNUM,
    DOCVSHIFT,
    INSERTDT,
    UPDATEDT,
    ENDDT,
    NDS,
    REALQUANT,
    PART_PARENT_ID,
    NAME_ID,
    IZG_ID,
    COUNTRY_ID,
    NAC,
    BLOCK_QUANT,
    BLOCK_COUNT,
    MMBSH,
    PART_TYPE,
    PRICES,
    BASE_AGENT_ID,
    SBASE_AGENT_ID,
    CONTRACT_ID,
    SCONTRACT_ID,
    GROUP_ID,
    VPART_ID,
    MNN)
AS
select
PART_ID,
WARE_ID,
SNAME,
SIZG,
SCOUNTRY,
ORIG_CODE,
SORIG_NAME,
SORIG_IZG,
SORIG_COUNTRY,
BCODE_IZG,
PRICE,
PRICE_O,
PRICE_Z,
PRICE_R,
QUANT,
BARCODE,
BARCODE1,
DEP,
(select intvalue from vals where id=name_id), --KRITK,
GODENDO,
SERIA,
SUM_NDSO,
SERT,
DATESERT,
KEMVSERT,
SDSERT,
REGN,
NGTD,
EDIZM,
DOC_ID,
DOCNUM,
DOCDATE,
DOCCAPTION,
DOCAGENT,
DOCVNUM,
DOCVSHIFT,
INSERTDT,
UPDATEDT,
ENDDT,
NDS,
REALQUANT,
PART_PARENT_ID,
NAME_ID,
IZG_ID,
COUNTRY_ID,
NAC,
BLOCK_QUANT,
BLOCK_COUNT,
(select membership from PR_MEMBERSHIPS('PARTS=' || wb.part_id || ';PARTS.NAME_ID=' || wb.name_id || ';PARTS.WARE_ID=' || wb.ware_ID || ';PARTS.IZG_ID=' || wb.izg_id ||';',ascii_char(13)||ascii_char(10),1)),
part_type,
(select s from PR_GETPARTPRICES(wb.part_id,0)),
BASE_AGENT_ID,
(select caption from agents where id=wb.BASE_AGENT_ID),
CONTRACT_ID,
SCONTRACT_ID,
GROUP_ID,
VPART_ID,
(select preparedvalue from vals where id=name_id)
from warebasenameid wb
;

CREATE OR ALTER VIEW VW_WAREBASE_KASSA(
    PART_ID,
    WARE_ID,
    SNAME,
    SIZG,
    SCOUNTRY,
    ORIG_CODE,
    SORIG_NAME,
    SORIG_IZG,
    SORIG_COUNTRY,
    BCODE_IZG,
    PRICE,
    PRICE_O,
    PRICE_Z,
    PRICE_R,
    QUANT,
    BARCODE,
    BARCODE1,
    DEP,
    KRITK,
    GODENDO,
    SERIA,
    SUM_NDSO,
    SERT,
    DATESERT,
    KEMVSERT,
    SDSERT,
    REGN,
    NGTD,
    EDIZM,
    DOC_ID,
    DOCNUM,
    DOCDATE,
    DOCCAPTION,
    DOCAGENT,
    DOCVNUM,
    DOCVSHIFT,
    INSERTDT,
    UPDATEDT,
    ENDDT,
    NDS,
    REALQUANT,
    PART_PARENT_ID,
    NAME_ID,
    IZG_ID,
    COUNTRY_ID,
    NAC,
    BLOCK_QUANT,
    BLOCK_COUNT,
    MMBSH,
    PART_TYPE,
    BASE_AGENT_ID,
    SBASE_AGENT_ID,
    GROUPS,
    CAPTION,
    CONTRACT_ID,
    SCONTRACT_ID,
    GROUP_ID,
    VPART_ID,
    PACKET,
    SORDERNAME,
    MNN,
    STORE_STRING,
    MALOHOD,
    SKLAD_ID)
AS
select
w.PART_ID,
w.WARE_ID,
w.SNAME,
w.SIZG,
w.SCOUNTRY,
w.ORIG_CODE,
w.SORIG_NAME,
w.SORIG_IZG,
w.SORIG_COUNTRY,
w.BCODE_IZG,
w.PRICE,
w.PRICE_O,
w.PRICE_Z,
w.PRICE_R,
w.QUANT,
w.BARCODE,
w.BARCODE1,
w.DEP,
w.KRITK,
w.GODENDO,
w.SERIA,
w.SUM_NDSO,
w.SERT,
w.DATESERT,
w.KEMVSERT,
w.SDSERT,
w.REGN,
w.NGTD,
w.EDIZM,
w.doc_id,
w.docnum,
w.docdate,
w.doccaption,
w.docagent,
w.docvnum,
w.docvshift,
w.INSERTDT,
w.UPDATEDT,
w.ENDDT,
w.NDS ,
w.REALQUANT,
w.PART_PARENT_ID,
w.NAME_ID,
w.IZG_ID,
w.COUNTRY_ID,
w.NAC,
w.BLOCK_QUANT,
w.BLOCK_COUNT,
w.MMBSH,
w.PART_TYPE,
w.BASE_AGENT_ID,
(select caption from agents where id=w.BASE_AGENT_ID),
(select membership from PR_MEMBERSHIPS('PARTS=' || w.part_id || ';PARTS.NAME_ID=' || w.name_id || ';PARTS.WARE_ID=' || w.ware_ID || ';PARTS.IZG_ID=' || w.izg_id ||';',ascii_char(13)||ascii_char(10))) as groups,
w.docagent,
W.contract_id,
W.scontract_id,
w.group_id,
w.vpart_id,
w.packet,
w.SNAME,
v.preparedvalue,
(select svalue from pr_getattribute('store_string', w.name_id)),
m.MALOHOD,
p.sklad_id
from warebase w
left join parts p on p.id = w.part_id
left join vals v on w.name_id=v.id and v.vtype=0
left join MALOHOD m on m.part_id = w.part_id
;

